<template>
  <div
    v-if="show"
    class="fixed inset-0 bg-black bg-opacity-50 flex items-center justify-center z-50"
    @click="close"
  >
    <div class="bg-white rounded-lg max-w-md w-full shadow-lg animate-slide-down" @click.stop>
      <div class="px-6 py-4 border-b border-gray-200 flex justify-between items-center">
        <slot name="header">
          <h3 class="text-lg font-semibold">Modal Title</h3>
          <button class="text-2xl font-bold leading-none" @click="close">×</button>
        </slot>
      </div>
      <div class="px-6 py-4">
        <slot name="body">
          <p>This is the default modal content.</p>
        </slot>
      </div>
      <div class="px-6 py-3 border-t border-gray-200 text-right">
        <slot name="footer">
          <button class="px-4 py-2 bg-blue-600 text-white rounded hover:bg-blue-700" @click="close">
            Close
          </button>
        </slot>
      </div>
    </div>
  </div>
</template>

<script setup lang="ts">
import { ref, defineProps, defineEmits, watch } from 'vue'

// TYPESCRIPT
interface ModalProps {
  show: boolean
}

// STATE VARIABLES
const props = defineProps<ModalProps>()
const emit = defineEmits(['close'])

// REF
// Variable 1 - reactive prop
const show = ref(props.show)

// METHODS
// Method 1 - watch to observe prop show changes
watch(show, (newValue) => {
  if (!newValue) {
    emit('close')
  }
})

// Method 2 - closeModal
const close = () => {
  show.value = false
  emit('close')
}
</script>

<style scoped>
@keyframes slide-down {
  from {
    transform: translateY(-100vh);
  }
  to {
    transform: translateY(0);
  }
}
</style>
